/**
 * Copyright shohei909 ( http://wonderfl.net/user/shohei909 )
 * MIT License ( http://www.opensource.org/licenses/mit-license.php )
 * Downloaded from: http://wonderfl.net/c/nKmz
 */

// forked from ProjectNya's 素数を探す
////////////////////////////////////////////////////////////////////////////////
// 素数を探す
////////////////////////////////////////////////////////////////////////////////

package {

    import flash.display.Sprite;
    import flash.display.Loader;
    import flash.events.Event;
    import flash.net.URLRequest;
    import flash.system.LoaderContext;
    import flash.display.Bitmap;
    import flash.filters.BlurFilter;
    import flash.display.Shape;
    import flash.text.TextField;
    import flash.text.TextFieldType;
    import flash.text.TextFieldAutoSize;
    import flash.text.AntiAliasType;
    import flash.text.TextFormat;
    import flash.text.TextFormatAlign;
    import flash.events.FocusEvent;
    import flash.ui.Keyboard;
    import flash.events.KeyboardEvent;

    [SWF(backgroundColor="#FFFFFF", width="465", height="465", frameRate="30")]

    public class Main extends Sprite {
        private var filePath:String = "http://www.project-nya.jp/images/flash/photo/p020.jpg";
        private var prime:uint = 2;
        private var primes:Array;
        private var max:uint;
        private var txt:Label;
        private var output:TextOutput;
        private var input:TextField;
        private var keyCode:int = 0;

        public function Main() {
            //Wonderfl.capture_delay(1);
            init();
        }

        private function init():void {
            var loader:Loader = new Loader();
            loader.contentLoaderInfo.addEventListener(Event.INIT, ready, false, 0, true);
            loader.load(new URLRequest(filePath), new LoaderContext(true));
        }
        private function setup():void {
            var rect:Shape = new Shape();
            rect.x = 70;
            rect.y = 12;
            addChild(rect);
            rect.graphics.beginFill(0xFFFFFF, 0.3);
            rect.graphics.drawRect(0, 0, 80, 20);
            rect.graphics.endFill();
            input = new TextField();
            addChild(input);
            input.x = 70;
            input.y = 12;
            input.width = 80;
            input.height = 20;
            input.type = TextFieldType.INPUT;
            input.selectable = true;
            //input.embedFonts = true;
            //input.antiAliasType = AntiAliasType.ADVANCED;
            var tf:TextFormat = new TextFormat();
            tf.font = "_ゴシック";
            tf.size = 12;
            tf.align = TextFormatAlign.CENTER;
            input.defaultTextFormat = tf;
            input.textColor = 0x000000;
            input.text = "10";
            input.addEventListener(FocusEvent.FOCUS_IN, focusIn, false, 0, true);
            input.addEventListener(FocusEvent.FOCUS_OUT, focusOut, false, 0, true);
        }
        private function focusIn(evt:FocusEvent):void {
            input.addEventListener(KeyboardEvent.KEY_DOWN, keyDown, false, 0, true);
            input.addEventListener(KeyboardEvent.KEY_UP, keyUp, false, 0, true);
        }
        private function focusOut(evt:FocusEvent):void {
            input.removeEventListener(KeyboardEvent.KEY_DOWN, keyDown);
            input.removeEventListener(KeyboardEvent.KEY_UP, keyUp, false);
        }
        private function  keyDown(evt:KeyboardEvent):void {
            keyCode = evt.charCode;
        }
        private function keyUp(evt:KeyboardEvent):void {
            if (evt.charCode == Keyboard.ENTER) {
                if (evt.charCode == keyCode) {
                    select();
                }
            }
        }
        private function select():void {
            var str:String = input.text;
            if (str == "") return;
            max = uint(str);
            if (max < 10) return;
            start();
        }
        private function start():void {
            input.selectable = false;
            prime = 2;
            primes = new Array();
            primes.push(prime);
            output.text = "";
            Threader.addThread( update );
        }
        private function update( t:Thread ):void {
            t.loop( function _():Boolean {
                if (prime >= max) { return false;  }
                prime ++;
                search(t);
                return true;
            })
        }
        private function search(t:Thread):void {
            var count:uint = 0;
            var n:uint = 0;
            t.loop( function _():Boolean{
                if( !(n < primes.length) ){ return false; }
                if (prime%primes[n] == 0) {
                    return false;
                } else {
                    count ++;
                }
                n++;
                return n < max;
            },function onComplete():void{
                if (count == primes.length) {
                    //素数である
                    primes.push(prime);
                } else {
                    //素数ではない
                }
                show();
            });
        }
        private function show():void {
            if (prime < max) {
                txt.text = prime + " まで計算中...。";
            } else {
                txt.text = prime + " まで計算。[" + primes.length+ "個]";
                output.text = String(primes);
                input.selectable = true;
            }
        }
        private function ready(evt:Event):void {
            evt.target.removeEventListener(Event.INIT, ready);
            var content:Bitmap = Bitmap(evt.target.content);
            content.x = int((465 - content.width)/2);
            content.y = int((465 - content.height)/2);
            addChild(content);
            content.filters = [new BlurFilter(64, 0, 3)];
            draw();
            setup();
        }
        private function draw():void {
            var label1:Label = new Label(40, 20);
            addChild(label1);
            label1.x = 32;
            label1.y = 12;
            label1.textColor = 0xFFFFFF;
            label1.text = "1から";
            var label2:Label = new Label(140, 20);
            label2.x = 152;
            label2.y = 12;
            addChild(label2);
            label2.textColor = 0xFFFFFF;
            label2.text = "までの素数を求める。";
            txt = new Label(150, 20);
            txt.x = 292;
            txt.y = 12;
            addChild(txt);
            txt.textColor = 0xCCCCCC;
            txt.text = "";
            //
            var rect:Shape = new Shape();
            rect.x = 22;
            rect.y = 42;
            addChild(rect);
            rect.graphics.beginFill(0x000000, 0.3);
            rect.graphics.drawRect(0, 0, 420, 400);
            rect.graphics.endFill();
            //
            output = new TextOutput(400, 360);
            output.x = 32;
            output.y = 52;
            addChild(output);
            output.textColor = 0xCCCCCC;
            output.text = "";
        }

    }

}


//////////////////////////////////////////////////
// TextOutputクラス
//////////////////////////////////////////////////

import flash.display.Sprite;
import flash.text.TextField;
import flash.text.TextFieldType;
import flash.text.TextFieldAutoSize;
import flash.text.AntiAliasType;
import flash.text.TextFormat;
import flash.text.TextFormatAlign;

class TextOutput extends Sprite {
    private var txt:TextField;
    private static var fontType:String = "_ゴシック";
    private var _width:uint = 20;
    private var _height:uint = 20;
    private var size:uint = 12;
    public static const LEFT:String = TextFormatAlign.LEFT;
    public static const CENTER:String = TextFormatAlign.CENTER;
    public static const RIGHT:String = TextFormatAlign.RIGHT;

    public function TextOutput(w:uint, h:uint, s:uint = 12, align:String = LEFT) {
        _width = w;
        _height = h;
        size = s;
        draw(align);
    }

    private function draw(align:String):void {
        txt = new TextField();
        addChild(txt);
        txt.width = _width;
        txt.height = _height;
        txt.autoSize = align;
        txt.type = TextFieldType.DYNAMIC;
        txt.selectable = true;
        //txt.embedFonts = true;
        //txt.antiAliasType = AntiAliasType.ADVANCED;
        txt.multiline = true;
        txt.wordWrap = true;
        var tf:TextFormat = new TextFormat();
        tf.font = fontType;
        tf.size = size;
        tf.align = align;
        txt.defaultTextFormat = tf;
        textColor = 0x000000;
    }
    public function set text(param:String):void {
        txt.text = param;
    }
    public function set textColor(param:uint):void {
        txt.textColor = param;
    }

}


//////////////////////////////////////////////////
// Labelクラス
//////////////////////////////////////////////////

import flash.display.Sprite;
import flash.text.TextField;
import flash.text.TextFieldType;
import flash.text.TextFieldAutoSize;
import flash.text.AntiAliasType;
import flash.text.TextFormat;
import flash.text.TextFormatAlign;

class Label extends Sprite {
    private var txt:TextField;
    private static var fontType:String = "_ゴシック";
    private var _width:uint = 20;
    private var _height:uint = 20;
    private var size:uint = 12;
    public static const LEFT:String = TextFormatAlign.LEFT;
    public static const CENTER:String = TextFormatAlign.CENTER;
    public static const RIGHT:String = TextFormatAlign.RIGHT;

    public function Label(w:uint, h:uint, s:uint = 12, align:String = LEFT) {
        _width = w;
        _height = h;
        size = s;
        draw(align);
    }

    private function draw(align:String):void {
        txt = new TextField();
        addChild(txt);
        txt.width = _width;
        txt.height = _height;
        txt.autoSize = align;
        txt.type = TextFieldType.DYNAMIC;
        txt.selectable = false;
        //txt.embedFonts = true;
        //txt.antiAliasType = AntiAliasType.ADVANCED;
        var tf:TextFormat = new TextFormat();
        tf.font = fontType;
        tf.size = size;
        tf.align = align;
        txt.defaultTextFormat = tf;
        textColor = 0x000000;
    }
    public function set text(param:String):void {
        txt.text = param;
    }
    public function set textColor(param:uint):void {
        txt.textColor = param;
    }

}


//////////////////////////////////////////////////
// CompoEventクラス
//////////////////////////////////////////////////

import flash.events.Event;

class CompoEvent extends Event {
    public static const SELECT:String = "select";
    public static const CHANGE:String = "change";
    public var value:*;

    public function CompoEvent(type:String, value:*) {
        super(type);
        this.value = value;
    }

    override public function clone():Event {
        return new CompoEvent(type, value);
    }

}
//Threaderライブラリ=================================================================================
    import flash.utils.Timer;
    import flash.utils.getTimer;
    import flash.events.Event;
    /**
     * ThreadクラスはThreaderによって実行されるスレッドのクラスです。
     */
    class Thread extends Object{
        static private var threadNum:int = 0;
        
        /** スレッドの優先度を指定します。推奨される値は0-1です。すべてのスレッドの優先度が1を超えていると、理論上は処理落ちが発生します。 */
        public var rate:Number = Threader.defaultRate;
        /** スレッドが正しく完了した時に呼び出される関数です。 */
        public var onComplete:Function;
        /** onCompleteに渡すパラメーターの配列です。 */
        public var onCompleteParams:Array;
        /** スレッドが破棄される時に呼び出される関数です。 */
        public var onRemove:Function;
        /** onRemoveに渡すパラメーターの配列です */
        public var onRemoveParams:Array;
        
        /** スレッドの制限時間(ミリ秒)です。スレッドの実行時間がtimeoutを超えると、スレッドは中断されます。timeoutを0に設定すると制限時間はありません。 */
        public var timeout:uint = 0;
        /** スレッドがタイムアウトする時に呼び出される関数です。 */
        public var onTimeout:Function;
        /** onTimeoutに渡すパラメーターの配列です。 */
        public var onTimeoutParams:Array;
        /** このスレッドの待機時間です。 */
        public var delay:int = 0;
        /** このスレッドの名前です。 */
        public var name:String = "";
        
        private var _span:Number = Threader.defaultRate;
        /** このスレッドの呼び出し間隔です。 */
        public function get span():Number { return _span; }
        public function set span(s:Number):void { _span = s; _timer.delay = s; }
    
        
        private var _currentLoop:Loop = null;
        /** 現在進行中のループ処理です。 */
        public function get currentLoop():Loop { return _currentLoop; }
        
        private var _end:Boolean = false;
        /** このスレッドが終了しているかどうかのBoolean値です。 */
        public function get removed():Boolean { return _end; }
        private var _loops:Vector.<Loop> = new Vector.<Loop>();
        private var  _limit:int = 5, _startTime:int = 0, _stopTime:int = 0, _waitTime:int = 0, _added:Boolean, currentLoops:Vector.<Loop>;
        private var _timer:Timer;
        /** このスレッドが現在進行中かどうかのBoolean値です。 */
        public function get running():Boolean { return _timer.running; } 
        
        function Thread() {
            _timer = new Timer(span); 
            _startTime = getTimer();
            _timer.start();
            threadNum++;
            Threader.threads.push( this );
            _timer.addEventListener( "timer", onFrame  );
        }
        
        /**
         *  Threaderでは、loop関数で設定した関数を分割して実行することで、マルチスレッドが実現されます。
         * このとき、注意すべき点はloopMethodの一度の実行に長時間かかってしまう場合、処理落ちを起こすということです。
         * 
         * @param    loopMethod 繰り返し呼び出す関数です。この関数はfalseをかえすまで繰り返し呼び出されます。
         * @param    onComplete ループが終了したときに呼び出される関数です。
         * @param    name このループの名前です。
         */
        public function loop( loopMethod:Function, onComplete:Function = null, name:String = "" ):Loop{
            var loop:Loop = new Loop( _currentLoop, loopMethod, onComplete,name );
            if( _currentLoop == null ){ _loops.push( loop );
            }else { _currentLoop.loops.push( loop ); _added = true; }
            return loop;
        }
        
        /**
         * このスレッドを破棄します。
         */
        public function remove():void {
            if( onRemove != null ){ onRemove() }
            threadNum--; 
            Threader.threads.splice( Threader.threads.indexOf( this ), 1 );
            _end = true;
            _loops = null;
            _currentLoop = null;
            currentLoops = null;
            _timer.stop();
            _timer.removeEventListener( "timer", onFrame  );
        }
        
        /**
         * このスレッドを一時停止します。
         */
        public function pause():void 
        {
            if ( _timer.running ) { 
                _timer.stop();
                _stopTime = getTimer();
                if( delay <= 0 ){ threadNum--; }
            }
        }
        
        /**
         * このスレッドを再開します。
         */
        public function resume():void 
        {
            if ( !_timer.running ) { 
                _timer.start();
                _startTime = getTimer();
                if( delay <= 0 ){ threadNum++; }
            }
        }
        
        /**
         * 指定された時間(ミリ秒)だけスレッドを待機させます。
         */
        public function sleep( delay:int ):void 
        {
            if( delay > 0 ){
                if ( running && delay > 0 ) { threadNum--; }
                _waitTime = getTimer();
                _limit = -1; 
                this.delay = delay;
            }
        }
        
        private function onFrame(e:Event):void {
            if ( timeout != 0 && timeout <= getTimer() - _startTime ) { if(onTimeout != null ){onTimeout.apply(null,onTimeoutParams)}; remove(); return; }
            if ( delay > 0  ) {
                delay += -getTimer() + _waitTime;
                if ( delay <= 0 ) { delay = 0; threadNum++; }
                _waitTime = getTimer();
                _startTime += getTimer() - _waitTime;
            }else {
                var time:int = getTimer(); 
                _limit = Math.ceil((span * rate) / threadNum - 1);
                all: while(true){
                    if( _currentLoop == null ){
                        if ( _loops.length == 0 ) { 
                            if( onComplete != null ){ onComplete.apply(null,onCompleteParams) }
                            remove();
                            return;
                        }
                        currentLoops = _loops;
                        _currentLoop = currentLoops[0];
                    }
                    do{
                        if ( _limit < getTimer() - time ) { break all; }
                        var cont:Boolean = _currentLoop.func.apply( null, _currentLoop.params );
                    }while ( cont && _added == false)
                    if( cont != true ){
                        currentLoops.reverse(); currentLoops.pop(); currentLoops.reverse();
                    }
                    if ( _added ) {    _added = false; }
                    while( _currentLoop.loops.length == 0 ){
                        if( _currentLoop.onComplete != null ){ _currentLoop.onComplete() }
                        _currentLoop = _currentLoop.parent;
                        if( _currentLoop == null  ) { continue all; }
                    }
                    currentLoops = _currentLoop.loops;
                    _currentLoop = currentLoops[0];
                }
            }
        }
    }
    
     /**
     * LoopクラスはThreaderによって実行されるループ処理のクラスです。
     * @author shohei909
     */    
    class Loop extends Object{
        public var func:Function;
        public var params:Array;
        public var onComplete:Function;
        public var name:String;
        public var parent:Loop;
        public var loops:Vector.<Loop> = new Vector.<Loop>();
        function Loop( parent:Loop, func:Function, onComplete:Function = null, name:String = "" ){  
            this.func = func; this.onComplete = onComplete; this.parent = parent; this.name = name;
        }
    }
    /**
     * Threaderクラスはスレッドを実行するための静的なクラスです。
     * @author shohei909
     */
    class Threader extends Object{
        /** デフォルトの呼び出し間隔(ミリ秒)です。frameRateに合わせることで効率よく動作します。 */
        static public var defaultSpan:Number = 1000/60; 
        /** デフォルトの優先度です。 */
        static public var defaultRate:Number = 0.5;
        /** 全てのスレッドへの参照です。　*/
        static public var threads:Vector.<Thread> = new Vector.<Thread>();
        
        /**
         * addThreadはThreaderの核となる関数です。
         * 
         * Threaderでは、loop関数を含むFunctionをaddThread関数を使って実行することで、マルチスレッドが開始されます。
         * 
         * @param    threadMethod スレッドとして実行する関数です。funcの
         * @param    params threadMethodに渡すパラメーターの配列です。
         * @param    threadParameters スレッドに設定するパラメーターです。
         * @return    追加されたスレッドです。
         * @see Thread
         * @see Thread#loop()
         */
        static public function addThread( threadMethod:Function, threadParameters:Object = null, params:Array = null ):Thread {
            var thread:Thread = new Thread();
            for( var str:String in threadParameters ){
                thread[str] = threadParameters[str];
            }
            if ( params == null ) {
                thread.loop( threadMethod ).params = [thread]
            }else{
                thread.loop( threadMethod ).params = [thread].concat( params );
            }
            return thread;
        }
        
        /**
         * 全てのスレッドを破棄します。
         */
        static public function removeAllThreads():void { 
            for each( var t:Thread in threads ) { t.remove(); }
        }
        
        /**
         * 現在進行中の全てのスレッドを一時停止します。
         */
        static public function pauseAllThreads():void { 
            for each( var t:Thread in threads ) { t.pause(); }
        }
        
        /**
         * 現在一時停止の全てのスレッドを再開します。
         */
        static public function resumeAllThreads():void { 
            for each( var t:Thread in threads ) { t.resume(); }
        }
        
        /**
         * 全てのスレッドを指定した時間(ミリ秒)だけ待機させます。
         */
        static public function sleepAllThreads( delay:int ):void { 
            for each( var t:Thread in threads ) { t.sleep( delay ); }
        }
        
        /**
         * nameが一致する、スレッドを破棄します。
         */
        static public function removeThreads( name:String ):void { 
            for each( var t:Thread in threads ) { if(t.name==name)t.remove(); }
        }
        
        /**
         * nameが一致する、現在進行中のスレッドを一時停止します。
         */
        static public function pauseThreads( name:String ):void { 
            for each( var t:Thread in threads ) { if(t.name==name)t.pause(); }
        }
        
        /**
         * nameが一致する、現在一時停止中のスレッドを再開します。
         */
        static public function resumeThreads( name:String ):void { 
            for each( var t:Thread in threads ) { if(t.name==name)t.resume(); }
        }
        
        /**
         * nameが一致する、スレッドを指定した時間(ミリ秒)だけ待機させます。
         */
        static public function sleepThreads( name:String, delay:int ):void { 
            for each( var t:Thread in threads ) { if(t.name==name)t.sleep( delay ); }
        }
    }
    
    
//Threaderライブラリここまで==========================================================================================================
